<?php

namespace ShineSoftware\Setefi\Controller\Hosted;

class Notifymybank extends \ShineSoftware\Setefi\Controller\Main {

    public function execute() {
        $storeManager = $this->_objectManager->get('\Magento\Store\Model\StoreManagerInterface');
        $orderId = $this->getRequest()->getParam('merchantorderid');
        $result = $this->getRequest()->getParam('result');
        $data = $this->getRequest()->getParams();
        $this->_logger->debug(__METHOD__ . " - " . json_encode($data));
        if ($result == "AUTHORISED" && !empty($orderId)) {
            $order = $this->getOrder($orderId);
            $this->_createTransaction($order, $data);
            $this->_createInvoice($order);
            $this->_sendOrderEmail($order);
            $url = $storeManager->getStore()->getUrl('checkout/onepage/success?paymentid=' . $data['paymentid'], ['_current' => true]);
        } elseif ($result == "PENDING" && !empty($orderId)) {
            //noop
        } elseif (!empty($orderId)) {
            if ($this->_cancelPayment($orderId, $result)) {
                $url = $storeManager->getStore()->getUrl('checkout/', ['_current' => true]);
            } else {
                $url = $storeManager->getStore()->getUrl('checkout/onepage/failure/', ['_current' => true]);
            }
        }
        die("$url");
    }
    
    protected function _cancelPayment($orderId = NULL, $errorMsg = '') {
        $errorMsg = trim(strip_tags($errorMsg));
        $this->_logger->debug(__METHOD__ . " - Bank Response: " . $errorMsg);
        $sessionOrder = $this->session->getLastRealOrder();
        if ($sessionOrder->getId() && $sessionOrder->getState() != Order::STATE_CANCELED && $sessionOrder->getIncrementId() == $orderId) {
            $this->_checkoutHelper->cancelCurrentOrder($errorMsg);
            if ($this->_checkoutSession->restoreQuote()) {
                $this->_logger->debug(__METHOD__ . " - Quote has been restored! The user will be redirect to the cart!");
                return true;
            } else {
                $this->_logger->debug(__METHOD__ . " - Quote has been NOT restored! The user will be redirected to the failure page!");
                return false;
            }
        } else {
            $order = $this->getOrder($orderId);
            if ($order && $order->getId() && $order->getState() != Order::STATE_CANCELED) {
                $order->registerCancellation()->save();
                return true;
            }
        }
        
    }

}

;
